// CADDemoView.cpp : implementation of the CCADDemoView class
//

#include "stdafx.h"
#include "CADDemo.h"

#include "CADDemoDoc.h"
#include "CADDemoView.h"
#include "uccdrawglobals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCADDemoView

IMPLEMENT_DYNCREATE(CCADDemoView, CFormView)

BEGIN_MESSAGE_MAP(CCADDemoView, CFormView)
	//{{AFX_MSG_MAP(CCADDemoView)
	ON_WM_SIZE()
	ON_COMMAND(ID_DRAW1, OnDraw1)
	ON_UPDATE_COMMAND_UI(ID_DRAW1, OnUpdateDraw1)
	ON_COMMAND(ID_DRAW2, OnDraw2)
	ON_UPDATE_COMMAND_UI(ID_DRAW2, OnUpdateDraw2)
	ON_COMMAND(ID_DRAW3, OnDraw3)
	ON_UPDATE_COMMAND_UI(ID_DRAW3, OnUpdateDraw3)
	ON_COMMAND(ID_DRAW4, OnDraw4)
	ON_UPDATE_COMMAND_UI(ID_DRAW4, OnUpdateDraw4)
	ON_COMMAND(ID_DRAW5, OnDraw5)
	ON_UPDATE_COMMAND_UI(ID_DRAW5, OnUpdateDraw5)
	ON_COMMAND(ID_DRAW6, OnDraw6)
	ON_UPDATE_COMMAND_UI(ID_DRAW6, OnUpdateDraw6)
	ON_COMMAND(ID_DRAW7, OnDraw7)
	ON_UPDATE_COMMAND_UI(ID_DRAW7, OnUpdateDraw7)
	ON_COMMAND(ID_DRAW8, OnDraw8)
	ON_UPDATE_COMMAND_UI(ID_DRAW8, OnUpdateDraw8)
	ON_COMMAND(ID_DRAW9, OnDraw9)
	ON_UPDATE_COMMAND_UI(ID_DRAW9, OnUpdateDraw9)
	ON_COMMAND(ID_DRAW10, OnDraw10)
	ON_UPDATE_COMMAND_UI(ID_DRAW10, OnUpdateDraw10)
	ON_COMMAND(ID_DRAW11, OnDraw11)
	ON_UPDATE_COMMAND_UI(ID_DRAW11, OnUpdateDraw11)
	ON_COMMAND(ID_DRAW12, OnDraw12)
	ON_UPDATE_COMMAND_UI(ID_DRAW12, OnUpdateDraw12)
	ON_COMMAND(ID_DRAW13, OnDraw13)
	ON_UPDATE_COMMAND_UI(ID_DRAW13, OnUpdateDraw13)
	ON_COMMAND(ID_DRAW14, OnDraw14)
	ON_UPDATE_COMMAND_UI(ID_DRAW14, OnUpdateDraw14)
	ON_COMMAND(ID_DRAW15, OnDraw15)
	ON_UPDATE_COMMAND_UI(ID_DRAW15, OnUpdateDraw15)
	ON_COMMAND(ID_DRAW16, OnDraw16)
	ON_UPDATE_COMMAND_UI(ID_DRAW16, OnUpdateDraw16)
	ON_COMMAND(ID_DRAW17, OnDraw17)
	ON_UPDATE_COMMAND_UI(ID_DRAW17, OnUpdateDraw17)
	ON_COMMAND(ID_DRAW18, OnDraw18)
	ON_UPDATE_COMMAND_UI(ID_DRAW18, OnUpdateDraw18)
	ON_COMMAND(ID_DRAW_START, OnDrawStart)
	ON_UPDATE_COMMAND_UI(ID_DRAW_START, OnUpdateDrawStart)
	ON_COMMAND(ID_DRAW_STOP, OnDrawStop)
	ON_UPDATE_COMMAND_UI(ID_DRAW_STOP, OnUpdateDrawStop)
	ON_COMMAND(ID_FO_DRAW_SELECT, OnFoDrawSelect)
	ON_COMMAND(ID_FO_DRAW_STATIC, OnFoDrawStatic)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_TEST_SUBGRAPH, OnTestSubgraph)
	ON_COMMAND(ID_TEST_UNSUBGRAPH, OnTestUnsubgraph)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCADDemoView construction/destruction

CCADDemoView::CCADDemoView()
	: CFormView(CCADDemoView::IDD)
{
	//{{AFX_DATA_INIT(CCADDemoView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_pIPictureDisp1 = NULL;
	m_pIPictureDisp2 = NULL;
	m_pIPictureDisp3 = NULL;
	m_pIPictureDisp4 = NULL;
	m_pIPictureDisp5 = NULL;
	m_pIPictureDisp6 = NULL;
	m_pIPictureDisp7 = NULL;
	m_pIPictureDisp8 = NULL;
	m_pIPictureDisp9 = NULL;
	m_pIPictureDisp10 = NULL;
	m_pIPictureDisp11 = NULL;
	m_pIPictureDisp12 = NULL;
	m_pIPictureDisp13 = NULL;
	m_pIPictureDisp14 = NULL;
	m_pIPictureDisp15 = NULL;
	m_pIPictureDisp16 = NULL;
	m_pIPictureDisp17 = NULL;
	m_pIPictureDisp18 = NULL;
	m_pIPictureDisp19 = NULL;
	m_pIPictureDisp20 = NULL;

}

CCADDemoView::~CCADDemoView()
{
	if (m_pIPictureDisp1 != NULL) 
	{
		int nRefCount = m_pIPictureDisp1->Release();
	}

	if (m_pIPictureDisp2 != NULL) 
	{
		int nRefCount = m_pIPictureDisp2->Release();
	}

	if (m_pIPictureDisp3 != NULL) 
	{
		int nRefCount = m_pIPictureDisp3->Release();
	}

	if (m_pIPictureDisp4 != NULL) 
	{
		int nRefCount = m_pIPictureDisp4->Release();
	}

	if (m_pIPictureDisp5 != NULL) 
	{
		int nRefCount = m_pIPictureDisp5->Release();
	}

	if (m_pIPictureDisp6 != NULL) 
	{
		int nRefCount = m_pIPictureDisp6->Release();
	}

	if (m_pIPictureDisp7 != NULL) 
	{
		int nRefCount = m_pIPictureDisp7->Release();
	}

	if (m_pIPictureDisp8 != NULL) 
	{
		int nRefCount = m_pIPictureDisp8->Release();
	}

	if (m_pIPictureDisp9 != NULL) 
	{
		int nRefCount = m_pIPictureDisp9->Release();
	}

	if (m_pIPictureDisp10 != NULL) 
	{
		int nRefCount = m_pIPictureDisp10->Release();
	}

	if (m_pIPictureDisp11 != NULL) 
	{
		int nRefCount = m_pIPictureDisp11->Release();
	}

	if (m_pIPictureDisp12 != NULL) 
	{
		int nRefCount = m_pIPictureDisp12->Release();
	}

	if (m_pIPictureDisp13 != NULL) 
	{
		int nRefCount = m_pIPictureDisp13->Release();
	}

	if (m_pIPictureDisp14 != NULL) 
	{
		int nRefCount = m_pIPictureDisp14->Release();
	}

	if (m_pIPictureDisp15 != NULL) 
	{
		int nRefCount = m_pIPictureDisp15->Release();
	}

	if (m_pIPictureDisp16 != NULL) 
	{
		int nRefCount = m_pIPictureDisp16->Release();
	}

	if (m_pIPictureDisp17 != NULL) 
	{
		int nRefCount = m_pIPictureDisp17->Release();
	}

	if (m_pIPictureDisp18 != NULL) 
	{
		int nRefCount = m_pIPictureDisp18->Release();
	}

	if (m_pIPictureDisp19 != NULL) 
	{
		int nRefCount = m_pIPictureDisp19->Release();
	}

	if (m_pIPictureDisp20 != NULL) 
	{
		int nRefCount = m_pIPictureDisp20->Release();
	}

}

void CCADDemoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCADDemoView)
	DDX_Control(pDX, IDC_TKDRAWCADCTRL1, m_XDrawCtrl);
	//}}AFX_DATA_MAP
}

BOOL CCADDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CCADDemoView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	CRect Rect;
    GetClientRect(Rect);
	m_XDrawCtrl.EnableContinueDraw(TRUE);
    m_XDrawCtrl.MoveWindow(Rect);
	m_XDrawCtrl.SetCanvasSize(2000,2000);
	m_XDrawCtrl.ShowToolBoxWindow(FALSE);
	if (m_XDrawCtrl.GetSafeHwnd() != NULL)
	{
		CRect rc;
		GetClientRect(&rc);
		m_XDrawCtrl.MoveWindow(0, 0, rc.Width(), rc.Height());
	}

	PICTDESC pictDesc;

	m_testBitmap1.LoadBitmap(IDB_BITMAP1);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap1;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp1 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp1) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp1->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap2.LoadBitmap(IDB_BITMAP2);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap2;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp2 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp2) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp2->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap3.LoadBitmap(IDB_BITMAP3);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap3;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp3 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp3) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp3->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap4.LoadBitmap(IDB_BITMAP4);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap4;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp4 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp4) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp4->AddRef();
	//m_testBitmap.DeleteObject();


	m_testBitmap5.LoadBitmap(IDB_BITMAP5);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap5;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp5 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp5) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp5->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap6.LoadBitmap(IDB_BITMAP6);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap6;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp6 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp6) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp6->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap7.LoadBitmap(IDB_BITMAP7);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap7;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp7 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp7) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp7->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap8.LoadBitmap(IDB_BITMAP8);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap8;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp8 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp8) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp8->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap9.LoadBitmap(IDB_BITMAP9);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap9;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp9 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp9) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp9->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap10.LoadBitmap(IDB_BITMAP10);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap10;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp10 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp10) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp10->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap11.LoadBitmap(IDB_BITMAP11);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap11;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp11 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp11) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp11->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap12.LoadBitmap(IDB_BITMAP12);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap12;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp12 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp12) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp12->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap13.LoadBitmap(IDB_BITMAP13);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap13;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp13 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp13) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp13->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap14.LoadBitmap(IDB_BITMAP14);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap14;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp14 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp14) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp14->AddRef();
	//m_testBitmap.DeleteObject();


	m_testBitmap15.LoadBitmap(IDB_BITMAP16);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap15;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp15 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp15) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp15->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap16.LoadBitmap(IDB_BITMAP18);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap16;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp16 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp16) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp16->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap17.LoadBitmap(IDB_BITMAP20);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap17;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp17 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp17) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp17->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap18.LoadBitmap(IDB_BITMAP24);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap18;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp18 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp18) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp18->AddRef();
	//m_testBitmap.DeleteObject();


	m_testBitmap19.LoadBitmap(IDB_BITMAP15);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap19;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp19 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp19) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp19->AddRef();
	//m_testBitmap.DeleteObject();

	m_testBitmap20.LoadBitmap(IDB_BITMAP22);
	pictDesc.picType = PICTYPE_BITMAP;
	pictDesc.bmp.hbitmap = (HBITMAP)m_testBitmap20;
//	pictDesc.bmp.hpal = (HPALETTE)CreatePalette(m_lpLogPal);
	pictDesc.cbSizeofstruct = sizeof (PICTDESC);
	m_pIPictureDisp20 = NULL;
	if (OleCreatePictureIndirect(&pictDesc, IID_IPictureDisp, FALSE, (void**)&m_pIPictureDisp20) != S_OK)
	{
		AfxMessageBox(_T("Failed to create IPictureDisp"));
		return;
	}
	m_pIPictureDisp20->AddRef();
	//m_testBitmap.DeleteObject();
}

/////////////////////////////////////////////////////////////////////////////
// CCADDemoView printing

BOOL CCADDemoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCADDemoView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCADDemoView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CCADDemoView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CCADDemoView diagnostics

#ifdef _DEBUG
void CCADDemoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CCADDemoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CCADDemoDoc* CCADDemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCADDemoDoc)));
	return (CCADDemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCADDemoView message handlers

void CCADDemoView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	CRect Rect;
    GetClientRect(Rect);
    if (m_XDrawCtrl.GetSafeHwnd() !=NULL) 
	{
        m_XDrawCtrl.MoveWindow(Rect);
		
        ShowScrollBar(SB_BOTH, FALSE);
    }	
}

void CCADDemoView::OnDraw1() 
{
	// TODO: Add your command handler code here

	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp1);
}

void CCADDemoView::OnUpdateDraw1(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI;
}

void CCADDemoView::OnDraw2() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp2);
}

void CCADDemoView::OnUpdateDraw2(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI;
}

void CCADDemoView::OnDraw3() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp3);
}

void CCADDemoView::OnUpdateDraw3(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw4() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp4);
}

void CCADDemoView::OnUpdateDraw4(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw5() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp5);
}

void CCADDemoView::OnUpdateDraw5(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw6() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp6);
}

void CCADDemoView::OnUpdateDraw6(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw7() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp7);
}

void CCADDemoView::OnUpdateDraw7(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw8() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp8);
}

void CCADDemoView::OnUpdateDraw8(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw9() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp9);
}

void CCADDemoView::OnUpdateDraw9(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw10() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp10);
}

void CCADDemoView::OnUpdateDraw10(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw11() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp11);
}

void CCADDemoView::OnUpdateDraw11(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw12() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp12);
}

void CCADDemoView::OnUpdateDraw12(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw13() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp13);
}

void CCADDemoView::OnUpdateDraw13(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw14() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp14);
}

void CCADDemoView::OnUpdateDraw14(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw15() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp15);
}

void CCADDemoView::OnUpdateDraw15(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw16() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp16);
}

void CCADDemoView::OnUpdateDraw16(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw17() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp17);
}

void CCADDemoView::OnUpdateDraw17(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDraw18()
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp18);
}

void CCADDemoView::OnUpdateDraw18(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDrawStart() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp19);
}

void CCADDemoView::OnUpdateDrawStart(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnDrawStop() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawImageNode(m_pIPictureDisp20);
}

void CCADDemoView::OnUpdateDrawStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCADDemoView::OnFoDrawSelect() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoDrawSelect();
}

void CCADDemoView::OnFoDrawStatic() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DrawCustomRect(FO_COMP_EDITBOX);
}

void CCADDemoView::OnEditUndo() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.Undo();
}

void CCADDemoView::OnEditRedo() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.Redo();
}

void CCADDemoView::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_XDrawCtrl.CanUndo());
}

void CCADDemoView::OnUpdateEditRedo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_XDrawCtrl.CanRedo());
}

void CCADDemoView::OnTestSubgraph() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.DoMakeSubgraph();
}

void CCADDemoView::OnTestUnsubgraph() 
{
	// TODO: Add your command handler code here
	m_XDrawCtrl.UnGroupSubgraph();
}
